/* Copyright (C) Teemu Suutari */

#ifndef SDHCDECOMPRESSOR_HPP
#define SDHCDECOMPRESSOR_HPP

#include "XPKDecompressor.hpp"

class SDHCDecompressor : public XPKDecompressor
{
public:
	SDHCDecompressor(uint32_t hdr,uint32_t recursionLevel,const Buffer &packedData,std::unique_ptr<XPKDecompressor::State> &state,bool verify);

	virtual ~SDHCDecompressor();

	virtual const std::string &getSubName() const noexcept override final;

	virtual void decompressImpl(Buffer &rawData,const Buffer &previousData,bool verify) override final;

	static bool detectHeaderXPK(uint32_t hdr) noexcept;
	static std::unique_ptr<XPKDecompressor> create(uint32_t hdr,uint32_t recursionLevel,const Buffer &packedData,std::unique_ptr<XPKDecompressor::State> &state,bool verify);

private:
	const Buffer	&_packedData;

	uint16_t	_mode=0;

	static XPKDecompressor::Registry<SDHCDecompressor> _XPKregistration;
};

#endif
